// Part of AtomViewer: AtomViewer is a tool to display and analyse
// atomistic simulations
//
// Copyright (C) 2013  ICAMS, Ruhr-Universität Bochum
//
// AtomViewer is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// AtomViewer is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with AtomViewer. If not, see <http://www.gnu.org/licenses/> 

package model;

public class RBV {
	public float rbv_x, rbv_y, rbv_z, lineDirection_x, lineDirection_y, lineDirection_z;
	
	public RBV(float[] rbv, float[] lineSense) {
		this.rbv_x = rbv[0];
		this.rbv_y = rbv[1];
		this.rbv_z = rbv[2];
		this.lineDirection_x = lineSense[0];
		this.lineDirection_y = lineSense[1];
		this.lineDirection_z = lineSense[2];
	}
	
	private RBV(RBV rbv){
		this.rbv_x = rbv.rbv_x;
		this.rbv_y = rbv.rbv_y;
		this.rbv_z = rbv.rbv_z;
		this.lineDirection_x = rbv.lineDirection_x;
		this.lineDirection_y = rbv.lineDirection_y;
		this.lineDirection_z = rbv.lineDirection_z;
	}
	
	public float[] getRBVAsVector(){
		return new float[]{rbv_x, rbv_y, rbv_z};
	}
	
	public float[] getLineDirectionAsVector(){
		return new float[]{lineDirection_x, lineDirection_y, lineDirection_z};
	}
	
	public float getSquaredRBVLengh(){
		return rbv_x*rbv_x+rbv_y*rbv_y+rbv_z*rbv_z;
	}
	
	public RBV clone() {
		return new RBV(this);
	}
}
