package model.polygrain.kdTree;

import model.Coordinate;

/**
 * Original code released under the Gnu Lesser General Public License:
 * http://home.wlu.edu/~levys/software/kd/
 */
class HRect {

	protected float minX = 0,minY = 0, minZ = 0;
	protected float maxX = 0,maxY = 0, maxZ = 0;

	protected HRect() {}

	protected HRect(HRect h) {
		minX = h.minX; minY = h.minY; minZ = h.minZ;
		maxX = h.maxX; maxY = h.maxY; maxZ = h.maxZ;
	}

	protected HRect clone() {
		return new HRect(this);
	}

	protected float[] closest(Coordinate t) {
		float[] p = new float[3];

		if (t.getX() <= minX) {
			p[0] = minX;
		} else if (t.getX() >= maxX) {
			p[0] = maxX;
		} else {
			p[0] = t.getX();
		}
		
		if (t.getY() <= minY) {
			p[1] = minY;
		} else if (t.getY() >= maxY) {
			p[1] = maxY;
		} else {
			p[1] = t.getY();
		}
		
		if (t.getZ() <= minZ) {
			p[2] = minZ;
		} else if (t.getZ() >= maxZ) {
			p[2] = maxZ;
		} else {
			p[2] = t.getZ();
		}

		return p;
	}

	protected static HRect infiniteHRect() {
		HRect h = new HRect();
		h.maxX = Float.POSITIVE_INFINITY;
		h.maxY = Float.POSITIVE_INFINITY;
		h.maxZ = Float.POSITIVE_INFINITY;
		
		h.minX = Float.NEGATIVE_INFINITY;
		h.minY = Float.NEGATIVE_INFINITY;
		h.minZ = Float.NEGATIVE_INFINITY;
		return h;
	}
}
